/**************************************************************************
*
* Filename:     CAAttribute.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Benutzerdefinierte Attributklasse
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace ManagedMSI
{
	using System;

	/// <summary>
	/// Benutzerdefinierte Attributklasse
	/// </summary>
	[Serializable, AttributeUsage(AttributeTargets.Method)]
	internal sealed class DllExportAttribute : Attribute
	{
		#region Initalize
		/// <summary>
		/// Neue Instanz des Objektes erstellen
		/// </summary>
		public DllExportAttribute() { }

		/// <summary>
		/// Neue Instanz des Objektes erstellen
		/// </summary>
		/// <param name="name">Name des Attributes</param>
		public DllExportAttribute(string name)
		{
			this.name = name;
		}
		#endregion

		#region Properties
		/// <summary>
		/// Gibt den Namen des Attributs zurck oder legt ihn fest
		/// </summary>
		public string Name
		{
			get { return this.name; }
			set { this.name = value; }
		}
		private string name;
		#endregion
	}
}
