/**************************************************************************
*
* Filename:     CAAttribute.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Attribute zum exportieren von Funktionen
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace PatchModell
{
	using System;

	/// <summary>
	/// Attribute zum exportieren von Funktionen
	/// </summary>
	[Serializable, AttributeUsage(AttributeTargets.Method)]
	internal sealed class DllExportAttribute : Attribute
	{
		#region Initalize
		/// <summary>
		/// Erstellt eine neue Instanz des Objektes
		/// </summary>
		public DllExportAttribute() { }

		/// <summary>
		/// Erstellt eine neue Instanz des Objektes
		/// </summary>
		/// <param name="name">Name des Attributes</param>
		public DllExportAttribute(string name)
		{
			this.name = name;
		}
		#endregion

		#region Properties
		/// <summary>
		/// Legt den Namen des Attributes fest oder gibt ihn zurck
		/// </summary>
		public string Name
		{
			get { return this.name; }
			set { this.name = value; }
		}
		private string name;
		#endregion
	}
}
