/**************************************************************************
*
* Filename:     CAClass.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Implementation for accessing the Windows Installer functionality
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace ManagedMSI
{
	using System;
	using System.Runtime.InteropServices;

	/// <summary>
	/// Implementation for accessing the Windows Installer functionality
	/// </summary>
	public class ExpClass
	{
		#region Constants
		/// <summary>
		/// The action completed successfully
		/// </summary>
		private const int ERROR_SUCCESS = 0;

		/// <summary>
		/// The user cancels installation.
		/// </summary>
		private const int ERROR_INSTALL_USEREXIT = 1602;

		/// <summary>
		/// A fatal error occurred during installation.
		/// </summary>
		private const int ERROR_INSTALL_FAILURE = 1603;

		#endregion

		#region Methods
		/// <summary>
		/// Sample method for accessing Windows Installer functionality
		/// </summary>
		/// <param name="hSession">Windows Installer Session</param>
		/// <returns>Custom Action Return Value</returns>
		[DllExportAttribute()]
		public static int SetTargetDir(uint hSession)
		{
			// Ordner der Runtime bestimmen
			string runtimeFolder = RuntimeEnvironment.GetRuntimeDirectory();

			// Name des Windows Installer-Properties festlegen
			string propertyName = "INSTALLLOCATION";

			// Ermittelte Eigenschaft an die aktuelle Installationssession bertragen
			MsiFunctions.SetProperty(hSession, propertyName, runtimeFolder);  

			// Rckgabe
			return (ERROR_SUCCESS);
		}
		#endregion
	}
}
