'**************************************************************************
'*
'* Filename:     CAAttribute.vb
'* Author:       Andreas Kerl (andreaskerl@msn.com)
'*               http://www.microsoft.com/germany/
'*
'* Description:  Custom Attribute for exporting Functions
'*				
'*
'*
'* Copyright 2005, Andreas Kerl
'* 
'**************************************************************************/

''' <summary>
''' Custom Attribute for exporting Functions.
''' </summary>
<Serializable(), AttributeUsage(AttributeTargets.Method)> _
Friend NotInheritable Class DllExportAttribute
       	Inherits Attribute

	#Region "Initalize"
	''' <summary>
	''' Creates a new instance of this object
	''' </summary>
        Public Sub New()
       	End Sub

	''' <summary>
	''' Creates a new instance of this object
	''' </summary>
	''' <param name="name">Name of the attribute</param>
        Public Sub New(ByVal name As String)
       		Me.Name = name
        End Sub
	#End Region

	#Region "Properties"
	''' <summary>
	''' Get or sets the name of the attribute
	''' </summary>
	Public Property Name() As String
		Get
                	Return Me.szname
	        End Get
            	Set(ByVal Value As String)
                	Me.szname = Value
            	End Set
        End Property
        Private szname As String
	#End Region
End Class

