/**************************************************************************
*
* Filename:     Helper.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Funktionen zum Anzeigen der Hilfe
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace Darwin.Common
{
	using System;
	using System.Windows.Forms;

	/// <summary>
	/// Funktionen zum Anzeigen der Hilfe
	/// </summary>
	public class Helper
	{
		#region Methoden

		/// <summary>
		/// Zeigt die Hilfe an
		/// </summary>
		/// <param name="productCode">ProductCode</param>
		/// <param name="featureName">Name des Features</param>
		/// <param name="componentId">ComponentID</param>
		public static void ShowHelp(string productCode, string featureName, string componentId)
		{
			Helper.ShowHelp(System.Windows.Forms.HelpNavigator.TableOfContents, string.Empty, productCode, featureName, componentId);
		}

		/// <summary>
		/// Zeigt die Hilfe an
		/// </summary>
		/// <param name="helpNavigator">Modus der Anzeige</param>
		/// <param name="helpTopic">Topic der verwendet werden soll</param>
		/// <param name="productCode">ProductCode</param>
		/// <param name="featureName">Name des Features</param>
		/// <param name="componentId">ComponentID</param>
		public static void ShowHelp(System.Windows.Forms.HelpNavigator helpNavigator, string helpTopic, string productCode, string featureName, string componentId)
		{
			// Bestimmt die Hilfedatei
			string helpFile = NativeMsi.ProvideComponent(productCode, featureName, componentId);

			// Hilfe aufrufen
			Help.ShowHelp(new Control(), helpFile, helpNavigator, helpTopic);
		}

		#endregion
	}
}
