/**************************************************************************
*
* Filename:     Form1.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Dialog zur Darstellung der Windows Installer GUIDs
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace Darwin
{
	using System;
	using System.Drawing;
	using System.ComponentModel;
	using System.Windows.Forms;
	/// <summary>
	/// Dialog zur Darstellung der Windows Installer GUIDs
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Controls
		private System.Windows.Forms.TextBox txtGUID;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnGenerate;
		private System.Windows.Forms.Label lblHeader;
		private System.Windows.Forms.Label lblGUID;
		private System.Windows.Forms.Panel panelMain;
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.StatusBarPanel PanelStatus;
		private System.Windows.Forms.StatusBarPanel PanelVersion;
		private System.Windows.Forms.Button btnHelp;
		private System.ComponentModel.Container components = null;
		#endregion

		#region Initialisierung / Finalisierung

		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		public Form1()
		{
			// Komponenten initialisieren
			InitializeComponent();

			// Hintergrundfarbe setzen
			this.SetSpecialColor(this.panelMain );  

			// AssemblyInformationen auslesen
			System.Reflection.Assembly Asm = System.Reflection.Assembly.GetExecutingAssembly();
			this.PanelVersion.Text = "Version: " + Asm.GetName().Version.ToString();

			// GUID generieren
			this.GenerateGUID();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.lblHeader = new System.Windows.Forms.Label();
			this.lblGUID = new System.Windows.Forms.Label();
			this.btnClose = new System.Windows.Forms.Button();
			this.txtGUID = new System.Windows.Forms.TextBox();
			this.panelMain = new System.Windows.Forms.Panel();
			this.btnHelp = new System.Windows.Forms.Button();
			this.btnGenerate = new System.Windows.Forms.Button();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.PanelStatus = new System.Windows.Forms.StatusBarPanel();
			this.PanelVersion = new System.Windows.Forms.StatusBarPanel();
			this.panelMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.PanelStatus)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.PanelVersion)).BeginInit();
			this.SuspendLayout();
			// 
			// lblHeader
			// 
			this.lblHeader.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblHeader.Location = new System.Drawing.Point(8, 8);
			this.lblHeader.Name = "lblHeader";
			this.lblHeader.Size = new System.Drawing.Size(376, 32);
			this.lblHeader.TabIndex = 3;
			this.lblHeader.Text = "Diese Anwendung ermglicht es eine Windows Installer konforme GUID zu generieren " +
				"und diese GUID in bestimmten Formaten darszustellen:";
			// 
			// lblGUID
			// 
			this.lblGUID.AutoSize = true;
			this.lblGUID.Location = new System.Drawing.Point(8, 48);
			this.lblGUID.Name = "lblGUID";
			this.lblGUID.Size = new System.Drawing.Size(132, 17);
			this.lblGUID.TabIndex = 4;
			this.lblGUID.Text = "GUID im Standardformat:";
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnClose.Location = new System.Drawing.Point(317, 128);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 2;
			this.btnClose.Text = "B&eenden";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// txtGUID
			// 
			this.txtGUID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtGUID.BackColor = System.Drawing.SystemColors.Window;
			this.txtGUID.Location = new System.Drawing.Point(8, 72);
			this.txtGUID.Name = "txtGUID";
			this.txtGUID.ReadOnly = true;
			this.txtGUID.Size = new System.Drawing.Size(384, 21);
			this.txtGUID.TabIndex = 5;
			this.txtGUID.Text = "";
			// 
			// panelMain
			// 
			this.panelMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panelMain.BackColor = System.Drawing.SystemColors.ControlLight;
			this.panelMain.Controls.Add(this.btnHelp);
			this.panelMain.Controls.Add(this.lblHeader);
			this.panelMain.Controls.Add(this.lblGUID);
			this.panelMain.Controls.Add(this.txtGUID);
			this.panelMain.Controls.Add(this.btnGenerate);
			this.panelMain.Controls.Add(this.btnClose);
			this.panelMain.Location = new System.Drawing.Point(16, 16);
			this.panelMain.Name = "panelMain";
			this.panelMain.Size = new System.Drawing.Size(400, 160);
			this.panelMain.TabIndex = 0;
			// 
			// btnHelp
			// 
			this.btnHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnHelp.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnHelp.Location = new System.Drawing.Point(232, 128);
			this.btnHelp.Name = "btnHelp";
			this.btnHelp.TabIndex = 1;
			this.btnHelp.Text = "&Hilfe";
			this.btnHelp.Click += new System.EventHandler(this.btnHelp_Click);
			// 
			// btnGenerate
			// 
			this.btnGenerate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnGenerate.BackColor = System.Drawing.SystemColors.Control;
			this.btnGenerate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnGenerate.Location = new System.Drawing.Point(112, 128);
			this.btnGenerate.Name = "btnGenerate";
			this.btnGenerate.Size = new System.Drawing.Size(112, 23);
			this.btnGenerate.TabIndex = 0;
			this.btnGenerate.Text = "&GUID generieren";
			this.btnGenerate.Click += new System.EventHandler(this.btnGenerate_Click);
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 197);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.PanelStatus,
																					 this.PanelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(432, 22);
			this.stBar.TabIndex = 1;
			// 
			// PanelStatus
			// 
			this.PanelStatus.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.PanelStatus.Icon = ((System.Drawing.Icon)(resources.GetObject("PanelStatus.Icon")));
			this.PanelStatus.Text = "Aktivieren Sie die Schaltflche \"GUID generieren\" ...";
			this.PanelStatus.Width = 276;
			// 
			// PanelVersion
			// 
			this.PanelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("PanelVersion.Icon")));
			this.PanelVersion.Width = 140;
			// 
			// Form1
			// 
			this.AcceptButton = this.btnGenerate;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.btnClose;
			this.ClientSize = new System.Drawing.Size(432, 219);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.panelMain);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(440, 248);
			this.Name = "Form1";
			this.Text = "Darwin Descriptor 1.0";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.panelMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.PanelStatus)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.PanelVersion)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new Form1());
		}
		#endregion

		#region Methoden

		/// <summary>
		/// Generiert die GUID
		/// </summary>
		private void GenerateGUID()
		{
			try
			{
				// GUID generieren, formatieren und in Textbox anzeigen
				// Achtung: MSI bentigt GUID ohne Kleinbuchstaben
				string Value = System.Guid.NewGuid().ToString().ToUpper(); 
  
				string guidValue = string.Format("{{{0}}}", Value); 

				this.txtGUID.Text = guidValue;
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}


		/// <summary>
		/// Border um das Panel zeichnen
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void DrawPanelBorder(System.Windows.Forms.Panel panel,System.Windows.Forms.PaintEventArgs e)
		{
			// Rahmen um Panel zeichnen
			e.Graphics.DrawRectangle(System.Drawing.SystemPens.ControlDark,panel.Bounds.Left-1, panel.Bounds.Top -1, panel.Bounds.Width+1,panel.Bounds.Height+1);  
		}

		/// <summary>
		/// Verndert die Farbe des Controls, falls die bisherige Farbe identisch mit der Form ist
		/// </summary>
		/// <param name="control">Control</param>
		private void SetSpecialColor(System.Windows.Forms.Control control)
		{
			try
			{
				// Farbe evtl setzen
				if ( control.BackColor.ToArgb() == control.Parent.BackColor.ToArgb() )
					control.BackColor = System.Drawing.SystemColors.ControlLightLight ;   
			}
			catch (Exception ex)
			{
				// Exception
				System.Diagnostics.Trace.WriteLine(ex.Message);  
			}
		}

		/// <summary>
		/// Paint-Ereignis
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			this.DrawPanelBorder(this.panelMain,e); 
		
		}

		/// <summary>
		/// Resize-Ereignis
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void Form1_Resize(object sender, System.EventArgs e)
		{
			this.Invalidate(false); 
		}

		/// <summary>
		/// Button "Generate" wurde aktiviert
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnGenerate_Click(object sender, System.EventArgs e)
		{
			this.GenerateGUID(); 
		}

		/// <summary>
		/// Button "Close" wurde aktiviert
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close(); 
		}

		/// <summary>
		/// Aufrufen der Hilfe
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnHelp_Click(object sender, System.EventArgs e)
		{
			// Productcode der Anwendung 
			const string HELPFILE_PRODUCTCODE = "{AA387173-BADA-4261-8B81-40207CDD14EB}";

			// Name des Features, dem die Komponente zugeordnet wurde
			const string HELPFILE_FEATURENAME = "Help";

			// ID der Komponente mit der Hilfedatei
			const string HELPFILE_COMPONENTID = "{39EB080E-692B-427D-AB50-93B4F7332D2F}";

			try
			{

				// Hilfe starten
				Common.Helper.ShowHelp(HELPFILE_PRODUCTCODE, HELPFILE_FEATURENAME, HELPFILE_COMPONENTID);
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}
		}
		#endregion
	}
}
