/**************************************************************************
*
* Filename:     Form1.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Dialog zur Darstellung der Windows Installer GUIDs
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace Darwin
{
	using System;
	using System.Drawing;
	using System.ComponentModel;
	using System.Windows.Forms;
	/// <summary>
	/// Dialog zur Darstellung der Windows Installer GUIDs
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Controls
		private System.Windows.Forms.TextBox txtGUID;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnGenerate;
		private System.Windows.Forms.Label lblHeader;
		private System.Windows.Forms.Label lblGUID;
		private System.Windows.Forms.Panel panelMain;
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.StatusBarPanel PanelStatus;
		private System.Windows.Forms.StatusBarPanel PanelVersion;
		private System.Windows.Forms.CheckBox chkClipboard;
		private System.Windows.Forms.Label lblID;
		private System.Windows.Forms.TextBox txtID;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnId;
		private System.Windows.Forms.Button btnGuid;
		private System.Windows.Forms.Button btnCompressed;
		private System.Windows.Forms.TextBox txtCompressed;
		private System.Windows.Forms.Label lblCompressed;
		private System.Windows.Forms.Button btnDarwin;
		private System.Windows.Forms.TextBox txtDarwin;
		private System.Windows.Forms.Label lblDarwin;
		private System.Windows.Forms.Button btnHelp;
		private System.ComponentModel.Container components = null;
		#endregion

		#region Initialisierung / Finalisierung

		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		public Form1()
		{
			// Komponenten initialisieren
			InitializeComponent();

			// Hintergrundfarbe setzen
			this.SetSpecialColor(this.panelMain );  

			// AssemblyInformationen auslesen
			System.Reflection.Assembly Asm = System.Reflection.Assembly.GetExecutingAssembly();
			this.PanelVersion.Text = "Version: " + Asm.GetName().Version.ToString();

			// GUID generieren
			this.GenerateGUID();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.lblHeader = new System.Windows.Forms.Label();
			this.lblGUID = new System.Windows.Forms.Label();
			this.btnClose = new System.Windows.Forms.Button();
			this.txtGUID = new System.Windows.Forms.TextBox();
			this.panelMain = new System.Windows.Forms.Panel();
			this.btnGuid = new System.Windows.Forms.Button();
			this.btnId = new System.Windows.Forms.Button();
			this.btnCompressed = new System.Windows.Forms.Button();
			this.btnDarwin = new System.Windows.Forms.Button();
			this.txtDarwin = new System.Windows.Forms.TextBox();
			this.lblDarwin = new System.Windows.Forms.Label();
			this.txtCompressed = new System.Windows.Forms.TextBox();
			this.lblCompressed = new System.Windows.Forms.Label();
			this.txtID = new System.Windows.Forms.TextBox();
			this.lblID = new System.Windows.Forms.Label();
			this.chkClipboard = new System.Windows.Forms.CheckBox();
			this.btnGenerate = new System.Windows.Forms.Button();
			this.btnDelete = new System.Windows.Forms.Button();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.PanelStatus = new System.Windows.Forms.StatusBarPanel();
			this.PanelVersion = new System.Windows.Forms.StatusBarPanel();
			this.btnHelp = new System.Windows.Forms.Button();
			this.panelMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.PanelStatus)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.PanelVersion)).BeginInit();
			this.SuspendLayout();
			// 
			// lblHeader
			// 
			this.lblHeader.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblHeader.Location = new System.Drawing.Point(8, 8);
			this.lblHeader.Name = "lblHeader";
			this.lblHeader.Size = new System.Drawing.Size(384, 32);
			this.lblHeader.TabIndex = 0;
			this.lblHeader.Text = "Diese Anwendung ermglicht es eine Windows Installer konforme GUID zu generieren " +
				"und diese GUID in bestimmten Formaten darszustellen:";
			// 
			// lblGUID
			// 
			this.lblGUID.AutoSize = true;
			this.lblGUID.Location = new System.Drawing.Point(8, 48);
			this.lblGUID.Name = "lblGUID";
			this.lblGUID.Size = new System.Drawing.Size(132, 17);
			this.lblGUID.TabIndex = 1;
			this.lblGUID.Text = "GUID im Standardformat:";
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnClose.Location = new System.Drawing.Point(432, 112);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(80, 23);
			this.btnClose.TabIndex = 4;
			this.btnClose.Text = "B&eenden";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// txtGUID
			// 
			this.txtGUID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtGUID.BackColor = System.Drawing.SystemColors.Window;
			this.txtGUID.Location = new System.Drawing.Point(8, 64);
			this.txtGUID.MaxLength = 38;
			this.txtGUID.Name = "txtGUID";
			this.txtGUID.Size = new System.Drawing.Size(360, 21);
			this.txtGUID.TabIndex = 2;
			this.txtGUID.Text = "";
			this.txtGUID.DoubleClick += new System.EventHandler(this.txt_DoubleClick);
			// 
			// panelMain
			// 
			this.panelMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panelMain.BackColor = System.Drawing.SystemColors.ControlLight;
			this.panelMain.Controls.Add(this.btnGuid);
			this.panelMain.Controls.Add(this.btnId);
			this.panelMain.Controls.Add(this.btnCompressed);
			this.panelMain.Controls.Add(this.btnDarwin);
			this.panelMain.Controls.Add(this.txtDarwin);
			this.panelMain.Controls.Add(this.lblDarwin);
			this.panelMain.Controls.Add(this.txtCompressed);
			this.panelMain.Controls.Add(this.lblCompressed);
			this.panelMain.Controls.Add(this.txtID);
			this.panelMain.Controls.Add(this.txtGUID);
			this.panelMain.Controls.Add(this.lblID);
			this.panelMain.Controls.Add(this.chkClipboard);
			this.panelMain.Controls.Add(this.lblHeader);
			this.panelMain.Controls.Add(this.lblGUID);
			this.panelMain.Location = new System.Drawing.Point(16, 16);
			this.panelMain.Name = "panelMain";
			this.panelMain.Size = new System.Drawing.Size(408, 304);
			this.panelMain.TabIndex = 0;
			// 
			// btnGuid
			// 
			this.btnGuid.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnGuid.BackColor = System.Drawing.SystemColors.Control;
			this.btnGuid.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnGuid.Location = new System.Drawing.Point(376, 64);
			this.btnGuid.Name = "btnGuid";
			this.btnGuid.Size = new System.Drawing.Size(24, 23);
			this.btnGuid.TabIndex = 3;
			this.btnGuid.Text = "...";
			this.btnGuid.Click += new System.EventHandler(this.btnGuid_Click);
			// 
			// btnId
			// 
			this.btnId.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnId.BackColor = System.Drawing.SystemColors.Control;
			this.btnId.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnId.Location = new System.Drawing.Point(376, 128);
			this.btnId.Name = "btnId";
			this.btnId.Size = new System.Drawing.Size(24, 23);
			this.btnId.TabIndex = 7;
			this.btnId.Text = "...";
			this.btnId.Click += new System.EventHandler(this.btnId_Click);
			// 
			// btnCompressed
			// 
			this.btnCompressed.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCompressed.BackColor = System.Drawing.SystemColors.Control;
			this.btnCompressed.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCompressed.Location = new System.Drawing.Point(376, 176);
			this.btnCompressed.Name = "btnCompressed";
			this.btnCompressed.Size = new System.Drawing.Size(24, 23);
			this.btnCompressed.TabIndex = 10;
			this.btnCompressed.Text = "...";
			this.btnCompressed.Click += new System.EventHandler(this.btnCompressed_Click);
			// 
			// btnDarwin
			// 
			this.btnDarwin.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDarwin.BackColor = System.Drawing.SystemColors.Control;
			this.btnDarwin.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnDarwin.Location = new System.Drawing.Point(376, 224);
			this.btnDarwin.Name = "btnDarwin";
			this.btnDarwin.Size = new System.Drawing.Size(24, 23);
			this.btnDarwin.TabIndex = 13;
			this.btnDarwin.Text = "...";
			this.btnDarwin.Click += new System.EventHandler(this.btnDarwin_Click);
			// 
			// txtDarwin
			// 
			this.txtDarwin.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtDarwin.BackColor = System.Drawing.SystemColors.Window;
			this.txtDarwin.Location = new System.Drawing.Point(8, 224);
			this.txtDarwin.MaxLength = 0;
			this.txtDarwin.Multiline = true;
			this.txtDarwin.Name = "txtDarwin";
			this.txtDarwin.Size = new System.Drawing.Size(360, 72);
			this.txtDarwin.TabIndex = 12;
			this.txtDarwin.Text = "";
			// 
			// lblDarwin
			// 
			this.lblDarwin.AutoSize = true;
			this.lblDarwin.Location = new System.Drawing.Point(8, 208);
			this.lblDarwin.Name = "lblDarwin";
			this.lblDarwin.Size = new System.Drawing.Size(201, 17);
			this.lblDarwin.TabIndex = 11;
			this.lblDarwin.Text = "Geben Sie den \"&Darwin Descriptor\" ein:";
			// 
			// txtCompressed
			// 
			this.txtCompressed.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtCompressed.BackColor = System.Drawing.SystemColors.Window;
			this.txtCompressed.Location = new System.Drawing.Point(8, 176);
			this.txtCompressed.MaxLength = 32;
			this.txtCompressed.Name = "txtCompressed";
			this.txtCompressed.Size = new System.Drawing.Size(360, 21);
			this.txtCompressed.TabIndex = 9;
			this.txtCompressed.Text = "";
			this.txtCompressed.DoubleClick += new System.EventHandler(this.txt_DoubleClick);
			// 
			// lblCompressed
			// 
			this.lblCompressed.AutoSize = true;
			this.lblCompressed.Location = new System.Drawing.Point(8, 160);
			this.lblCompressed.Name = "lblCompressed";
			this.lblCompressed.Size = new System.Drawing.Size(285, 17);
			this.lblCompressed.TabIndex = 8;
			this.lblCompressed.Text = "GUID im Format der Systemregistrierung (komprimiert):";
			// 
			// txtID
			// 
			this.txtID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtID.BackColor = System.Drawing.SystemColors.Window;
			this.txtID.Location = new System.Drawing.Point(8, 128);
			this.txtID.MaxLength = 36;
			this.txtID.Name = "txtID";
			this.txtID.Size = new System.Drawing.Size(360, 21);
			this.txtID.TabIndex = 6;
			this.txtID.Text = "";
			this.txtID.DoubleClick += new System.EventHandler(this.txt_DoubleClick);
			// 
			// lblID
			// 
			this.lblID.AutoSize = true;
			this.lblID.Location = new System.Drawing.Point(8, 112);
			this.lblID.Name = "lblID";
			this.lblID.Size = new System.Drawing.Size(156, 17);
			this.lblID.TabIndex = 5;
			this.lblID.Text = "GUID im Format fr Identifier:";
			// 
			// chkClipboard
			// 
			this.chkClipboard.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chkClipboard.Location = new System.Drawing.Point(8, 88);
			this.chkClipboard.Name = "chkClipboard";
			this.chkClipboard.Size = new System.Drawing.Size(352, 16);
			this.chkClipboard.TabIndex = 4;
			this.chkClipboard.Text = "Generierte GUID in die Zwischenablage &kopieren";
			// 
			// btnGenerate
			// 
			this.btnGenerate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnGenerate.BackColor = System.Drawing.SystemColors.Control;
			this.btnGenerate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnGenerate.Location = new System.Drawing.Point(432, 16);
			this.btnGenerate.Name = "btnGenerate";
			this.btnGenerate.Size = new System.Drawing.Size(80, 23);
			this.btnGenerate.TabIndex = 1;
			this.btnGenerate.Text = "&Generieren";
			this.btnGenerate.Click += new System.EventHandler(this.btnGenerate_Click);
			// 
			// btnDelete
			// 
			this.btnDelete.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDelete.BackColor = System.Drawing.SystemColors.Control;
			this.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnDelete.Location = new System.Drawing.Point(432, 48);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.Size = new System.Drawing.Size(80, 23);
			this.btnDelete.TabIndex = 2;
			this.btnDelete.Text = "&Lschen";
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 333);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.PanelStatus,
																					 this.PanelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(520, 22);
			this.stBar.TabIndex = 5;
			// 
			// PanelStatus
			// 
			this.PanelStatus.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.PanelStatus.Icon = ((System.Drawing.Icon)(resources.GetObject("PanelStatus.Icon")));
			this.PanelStatus.Text = "Aktivieren Sie die Schaltflche \"Generieren\" ...";
			this.PanelStatus.Width = 364;
			// 
			// PanelVersion
			// 
			this.PanelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("PanelVersion.Icon")));
			this.PanelVersion.Width = 140;
			// 
			// btnHelp
			// 
			this.btnHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnHelp.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnHelp.Location = new System.Drawing.Point(432, 80);
			this.btnHelp.Name = "btnHelp";
			this.btnHelp.Size = new System.Drawing.Size(80, 23);
			this.btnHelp.TabIndex = 3;
			this.btnHelp.Text = "&Hilfe";
			this.btnHelp.Click += new System.EventHandler(this.btnHelp_Click);
			// 
			// Form1
			// 
			this.AcceptButton = this.btnGenerate;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.btnClose;
			this.ClientSize = new System.Drawing.Size(520, 355);
			this.Controls.Add(this.btnHelp);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.panelMain);
			this.Controls.Add(this.btnGenerate);
			this.Controls.Add(this.btnDelete);
			this.Controls.Add(this.btnClose);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(440, 376);
			this.Name = "Form1";
			this.Text = "Darwin Descriptor 2.0";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.panelMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.PanelStatus)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.PanelVersion)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new Form1());
		}
		#endregion

		#region Methoden

		/// <summary>
		/// Generiert die GUID
		/// </summary>
		private void GenerateGUID()
		{
			// GUID generieren, formatieren und in Textbox anzeigen
			// Achtung: MSI bentigt GUID ohne Kleinbuchstaben
			string Value = System.Guid.NewGuid().ToString().ToUpper(); 

			string guidValue = string.Format("{{{0}}}", Value); 

			// Guid generieren
			this.GenerateGUID( guidValue );
		}

		/// <summary>
		/// Stellt die Guid in verschiedenen Formaten dar
		/// </summary>
		/// <param name="guidValue">Guid die verwendet werden soll</param>
		private void GenerateGUID(string guidValue)
		{
			try
			{
				this.txtGUID.Text = FormatGuid.PackGUID( guidValue, FormatGuid.GuidFormatStyle.Full ); 
				this.txtID.Text = FormatGuid.PackGUID( guidValue, FormatGuid.GuidFormatStyle.Merge); 
				this.txtCompressed.Text = FormatGuid.PackGUID( guidValue, FormatGuid.GuidFormatStyle.Compressed ); 

				// Bei Bedarf in die Zwischenablage kopieren
				if (this.chkClipboard.Checked)
				{
					Clipboard.SetDataObject(guidValue,true); 
				}
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}
		}

		/// <summary>
		/// Generiert die Guid, die jedoch vorher entpackt wird
		/// </summary>
		/// <param name="squidValue">Squid die umgewandelt werden soll</param>
		/// <param name="formatStyle">Darstellungsform der Guid</param>
		private void GenerateGUID(string squidValue, FormatGuid.GuidFormatStyle formatStyle)
		{
			try
			{
				// Guid entpacken
				string guid = FormatGuid.UnPackGUID( squidValue, formatStyle);
				
				// Werte hieraus generieren
				this.GenerateGUID(guid); 
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}
		}

		/// <summary>
		/// Border um das Panel zeichnen
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void DrawPanelBorder(System.Windows.Forms.Panel panel,System.Windows.Forms.PaintEventArgs e)
		{
			// Rahmen um Panel zeichnen
			e.Graphics.DrawRectangle(System.Drawing.SystemPens.ControlDark,panel.Bounds.Left-1, panel.Bounds.Top -1, panel.Bounds.Width+1,panel.Bounds.Height+1);  
		}

		/// <summary>
		/// Verndert die Farbe des Controls, falls die bisherige Farbe identisch mit der Form ist
		/// </summary>
		/// <param name="control">Control</param>
		private void SetSpecialColor(System.Windows.Forms.Control control)
		{
			try
			{
				// Farbe evtl setzen
				if ( control.BackColor.ToArgb() == control.Parent.BackColor.ToArgb() )
					control.BackColor = System.Drawing.SystemColors.ControlLightLight ;   
			}
			catch (Exception ex)
			{
				// Exception
				System.Diagnostics.Trace.WriteLine(ex.Message);  
			}
		}

		/// <summary>
		/// Paint-Ereignis
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			this.DrawPanelBorder(this.panelMain,e); 
		
		}

		/// <summary>
		/// Resize-Ereignis
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void Form1_Resize(object sender, System.EventArgs e)
		{
			this.Invalidate(false); 
		}

		/// <summary>
		/// Button "Generate" wurde aktiviert
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnGenerate_Click(object sender, System.EventArgs e)
		{
			this.GenerateGUID(); 
		}

		/// <summary>
		/// Button "Close" wurde aktiviert
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close(); 
		}

		/// <summary>
		/// Lscht alle Eingabefelder
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			this.txtGUID.Text = string.Empty;
			this.txtCompressed.Text = string.Empty;
			this.txtID.Text = string.Empty;
			this.txtDarwin.Text = string.Empty;  
		}

		/// <summary>
		/// Generiert die Guiddarstellungen auf Basis einer Standardguid
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnGuid_Click(object sender, System.EventArgs e)
		{
			string Value = this.txtGUID.Text; 
			this.GenerateGUID(Value); 
		
		}

		/// <summary>
		/// Generiert die Guiddarstellungen auf Basis einer Darstellung in Mergemodule
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnId_Click(object sender, System.EventArgs e)
		{
			this.GenerateGUID(this.txtID.Text,FormatGuid.GuidFormatStyle.Merge); 
		}

		/// <summary>
		/// Generiert die Guiddarstellungen auf Basis einer komprimierten Darstellung
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnCompressed_Click(object sender, System.EventArgs e)
		{
			this.GenerateGUID(this.txtCompressed.Text,FormatGuid.GuidFormatStyle.Compressed );

		}

		/// <summary>
		/// Entschlsselt den Darwin Descriptor
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnDarwin_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Zeilen in der Textbox abrufen
				string[] squidLines = this.txtDarwin.Lines;

				int lineNumber = 0;

				// Iteration durch die Linien
				foreach (string squidLine in squidLines)
				{
					lineNumber++;

					// Falls die Linie Zeichen enthlt
					if (squidLine.Trim() != string.Empty)
					{
						try
						{
							// Werte ermitteln
							DarwinValues Values = FormatGuid.LocateInstallerData( squidLine, lineNumber );

							// Form anzeigen
							Squids squidsForm = new Squids(Values);
							squidsForm.Show();
							Application.DoEvents(); 
						}
						catch (Exception ex)
						{
							// Exception
							MessageBox.Show(ex.Message,this.Text,MessageBoxButtons.OK,MessageBoxIcon.Warning);
						}
					}
				}
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message,this.Text,MessageBoxButtons.OK,MessageBoxIcon.Warning);
			}
		}
		
		/// <summary>
		/// Kopiert den Inhalt des Textfeldes in die Zwischenablage
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void txt_DoubleClick(object sender, System.EventArgs e)
		{
			TextBox box = (TextBox)sender;
		
			Clipboard.SetDataObject(box.Text ,true); 

		}
		
		/// <summary>
		/// Aufrufen der Hilfe
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void btnHelp_Click(object sender, System.EventArgs e)
		{
			// Productcode der Anwendung 
			const string HELPFILE_PRODUCTCODE = "{C3037F55-CB0A-46AA-9449-7722600A4230}";

			// Name des Features, dem die Komponente zugeordnet wurde
			const string HELPFILE_FEATURENAME = "Help";

			// ID der Komponente mit der Hilfedatei
			const string HELPFILE_COMPONENTID = "{39EB080E-692B-427D-AB50-93B4F7332D2F}";

			try
			{
				// Hilfe starten
				Common.Helper.ShowHelp(HELPFILE_PRODUCTCODE, HELPFILE_FEATURENAME, HELPFILE_COMPONENTID);
			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Warning );
			}
		}

		#endregion

	}
}
