/**************************************************************************
*
* Filename:     Squids.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Darstellung der Informationen aus dem Darwin Descriptor
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace Darwin
{
	using System;
	using System.Drawing;
	using System.Windows.Forms;
	/// <summary>
	/// Darstellung der Informationen aus dem Darwin Descriptor
	/// </summary>
	public class Squids : System.Windows.Forms.Form
	{
		#region Instanzvariablen
		private System.Windows.Forms.PropertyGrid gridSquids;
		private System.ComponentModel.Container components = null;
		#endregion

		#region Initialisierung / Finalisierung
		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		/// <param name="Values">Werte des Darwin Descriptors</param>
		public Squids(DarwinValues Values)
		{
			// Initialisierung der Komponenten
			InitializeComponent();

			// Titel und Objekt bergeben
			this.Text = string.Format("Darwin Descriptor [{0}]", Values.LineNumber.ToString());  
			this.gridSquids.SelectedObject = Values;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Squids));
			this.gridSquids = new System.Windows.Forms.PropertyGrid();
			this.SuspendLayout();
			// 
			// gridSquids
			// 
			this.gridSquids.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridSquids.CommandsVisibleIfAvailable = true;
			this.gridSquids.HelpBackColor = System.Drawing.SystemColors.ControlLight;
			this.gridSquids.LargeButtons = false;
			this.gridSquids.LineColor = System.Drawing.SystemColors.ControlLight;
			this.gridSquids.Location = new System.Drawing.Point(8, 8);
			this.gridSquids.Name = "gridSquids";
			this.gridSquids.Size = new System.Drawing.Size(600, 330);
			this.gridSquids.TabIndex = 0;
			this.gridSquids.Text = "PropertyGrid";
			this.gridSquids.ToolbarVisible = false;
			this.gridSquids.ViewBackColor = System.Drawing.SystemColors.Window;
			this.gridSquids.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// Squids
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(616, 350);
			this.Controls.Add(this.gridSquids);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.KeyPreview = true;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(480, 376);
			this.Name = "Squids";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "Darwin Descriptor";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.Squids_KeyDown);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methoden
		/// <summary>
		/// Schlieen
		/// </summary>
		/// <param name="sender">Objekt, welches aktiviert wurde</param>
		/// <param name="e">Ereignisargumente</param>
		private void Squids_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
				this.Close(); 
		}
		#endregion
	}
}
