/**************************************************************************
*
* Filename:     MsiForm.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Formular zum Starten der Installation
*				
*
*
* Copyright 2004, Andreas Kerl
* 
**************************************************************************/

namespace Advertise
{
	using System;
	using System.IO;
	using System.Windows.Forms;

	/// <summary>
	/// Formular zum Starten der Installation
	/// </summary>
	public class MsiForm : System.Windows.Forms.Form
	{
		#region Controls
		private System.Windows.Forms.Label lblPath;
		private System.Windows.Forms.TextBox txtFile;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.GroupBox gpMain;
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.StatusBarPanel panelVersion;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtScript;
		private System.Windows.Forms.Button btnScript;
		private System.Windows.Forms.TextBox txtTransform;
		private System.Windows.Forms.TextBox txtLanguage;
		private System.Windows.Forms.ComboBox cmbPlattform;
		private System.Windows.Forms.CheckBox chkInstance;
		private System.ComponentModel.Container components = null;

		#endregion

		#region Initialisierung / Finalisierung
		
		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		/// <param name="fileName">Name der Datei</param>
		public MsiForm(string fileName)
		{
			// Komponenten initialisierem
			InitializeComponent();

			// Dateiname bergeben
			this.txtFile.Text = fileName; 

			// Plattformen anfgen
			this.cmbPlattform.Items.AddRange(new string[] {"0 = Aktuelle Plattform", "1 = X86", "2 = IA64", "4 = AMD64"});  
			this.cmbPlattform.SelectedIndex = 0;

			// Version des MSI ermitteln
			this.panelVersion.Text = "Windows Installer-Version: " + MsiFunctions.GetVersion().ToString();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MsiForm));
			this.txtFile = new System.Windows.Forms.TextBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.lblPath = new System.Windows.Forms.Label();
			this.btnStart = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.gpMain = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.txtLanguage = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtTransform = new System.Windows.Forms.TextBox();
			this.btnScript = new System.Windows.Forms.Button();
			this.txtScript = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.cmbPlattform = new System.Windows.Forms.ComboBox();
			this.chkInstance = new System.Windows.Forms.CheckBox();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.panelVersion = new System.Windows.Forms.StatusBarPanel();
			this.gpMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).BeginInit();
			this.SuspendLayout();
			// 
			// txtFile
			// 
			this.txtFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtFile.Location = new System.Drawing.Point(16, 49);
			this.txtFile.Name = "txtFile";
			this.txtFile.Size = new System.Drawing.Size(328, 21);
			this.txtFile.TabIndex = 1;
			this.txtFile.Text = "";
			this.txtFile.TextChanged += new System.EventHandler(this.txtFile_TextChanged);
			// 
			// btnBrowse
			// 
			this.btnBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowse.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowse.Location = new System.Drawing.Point(352, 48);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(32, 23);
			this.btnBrowse.TabIndex = 2;
			this.btnBrowse.Text = "...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// lblPath
			// 
			this.lblPath.AutoSize = true;
			this.lblPath.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblPath.Location = new System.Drawing.Point(16, 27);
			this.lblPath.Name = "lblPath";
			this.lblPath.Size = new System.Drawing.Size(238, 17);
			this.lblPath.TabIndex = 0;
			this.lblPath.Text = "Datei von der das Skript generiert werden soll:";
			// 
			// btnStart
			// 
			this.btnStart.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnStart.Enabled = false;
			this.btnStart.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnStart.Location = new System.Drawing.Point(424, 16);
			this.btnStart.Name = "btnStart";
			this.btnStart.TabIndex = 1;
			this.btnStart.Text = "&Starten...";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(424, 48);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "B&eenden";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// gpMain
			// 
			this.gpMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gpMain.Controls.Add(this.label4);
			this.gpMain.Controls.Add(this.label3);
			this.gpMain.Controls.Add(this.txtLanguage);
			this.gpMain.Controls.Add(this.label2);
			this.gpMain.Controls.Add(this.txtTransform);
			this.gpMain.Controls.Add(this.btnScript);
			this.gpMain.Controls.Add(this.txtScript);
			this.gpMain.Controls.Add(this.label1);
			this.gpMain.Controls.Add(this.lblPath);
			this.gpMain.Controls.Add(this.txtFile);
			this.gpMain.Controls.Add(this.btnBrowse);
			this.gpMain.Controls.Add(this.cmbPlattform);
			this.gpMain.Controls.Add(this.chkInstance);
			this.gpMain.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.gpMain.Location = new System.Drawing.Point(16, 8);
			this.gpMain.Name = "gpMain";
			this.gpMain.Size = new System.Drawing.Size(400, 248);
			this.gpMain.TabIndex = 0;
			this.gpMain.TabStop = false;
			this.gpMain.Text = "Generieren eines Advertiseskript";
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label4.Location = new System.Drawing.Point(112, 167);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(54, 17);
			this.label4.TabIndex = 10;
			this.label4.Text = "Plattform:";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label3.Location = new System.Drawing.Point(16, 167);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(54, 17);
			this.label3.TabIndex = 9;
			this.label3.Text = "SprachID:";
			// 
			// txtLanguage
			// 
			this.txtLanguage.Location = new System.Drawing.Point(16, 184);
			this.txtLanguage.MaxLength = 4;
			this.txtLanguage.Name = "txtLanguage";
			this.txtLanguage.Size = new System.Drawing.Size(80, 21);
			this.txtLanguage.TabIndex = 8;
			this.txtLanguage.Text = "0";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Location = new System.Drawing.Point(16, 121);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(97, 17);
			this.label2.TabIndex = 7;
			this.label2.Text = "Transformationen:";
			// 
			// txtTransform
			// 
			this.txtTransform.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtTransform.Location = new System.Drawing.Point(16, 141);
			this.txtTransform.Name = "txtTransform";
			this.txtTransform.Size = new System.Drawing.Size(328, 21);
			this.txtTransform.TabIndex = 6;
			this.txtTransform.Text = "";
			// 
			// btnScript
			// 
			this.btnScript.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnScript.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnScript.Location = new System.Drawing.Point(352, 94);
			this.btnScript.Name = "btnScript";
			this.btnScript.Size = new System.Drawing.Size(32, 23);
			this.btnScript.TabIndex = 5;
			this.btnScript.Text = "...";
			this.btnScript.Click += new System.EventHandler(this.btnScript_Click);
			// 
			// txtScript
			// 
			this.txtScript.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtScript.Location = new System.Drawing.Point(16, 95);
			this.txtScript.Name = "txtScript";
			this.txtScript.Size = new System.Drawing.Size(328, 21);
			this.txtScript.TabIndex = 4;
			this.txtScript.Text = "";
			this.txtScript.TextChanged += new System.EventHandler(this.txtFile_TextChanged);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label1.Location = new System.Drawing.Point(16, 75);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(155, 17);
			this.label1.TabIndex = 3;
			this.label1.Text = "Skript das erstellt werden soll:";
			// 
			// cmbPlattform
			// 
			this.cmbPlattform.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbPlattform.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbPlattform.Location = new System.Drawing.Point(112, 187);
			this.cmbPlattform.Name = "cmbPlattform";
			this.cmbPlattform.Size = new System.Drawing.Size(232, 21);
			this.cmbPlattform.TabIndex = 4;
			// 
			// chkInstance
			// 
			this.chkInstance.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chkInstance.Location = new System.Drawing.Point(16, 216);
			this.chkInstance.Name = "chkInstance";
			this.chkInstance.Size = new System.Drawing.Size(296, 16);
			this.chkInstance.TabIndex = 4;
			this.chkInstance.Text = "Skript fr eine neue Instanz des Produktes erstellen";
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 274);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.panelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(512, 22);
			this.stBar.TabIndex = 3;
			// 
			// panelVersion
			// 
			this.panelVersion.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.panelVersion.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.panelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("panelVersion.Icon")));
			this.panelVersion.Width = 496;
			// 
			// MsiForm
			// 
			this.AcceptButton = this.btnStart;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(512, 296);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.gpMain);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnStart);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(520, 325);
			this.Name = "MsiForm";
			this.Text = "Windows Installer 3.1: Advertiseskript erstellen";
			this.gpMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// Haupteinstiegspunkt der Anwendung
		/// </summary>
		[STAThread]
		static void Main(string[] args) 
		{
			string fileName = string.Empty; 

			// Argumente auswerten
			if (args.Length > 0) 
				fileName = args[0];


			// Styles aktivieren und Form anzeigen
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new MsiForm(fileName));
		}
		#endregion

		#region Methoden
		/// <summary>
		/// Auswhlen einer Datei wurde aktiviert
		/// </summary>
		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			using (OpenFileDialog dlgOpen = new OpenFileDialog())
			{
				// Dialog initialisieren
				dlgOpen.Title = "Windows Installer-Datei auswhlen";
				dlgOpen.Filter = "Windows Installer-Datei (*.msi)|*.msi";
				dlgOpen.FileName = this.txtFile.Text;

				// Dialog anzeigen
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					// Datei in Textfeld anzeigen
					this.txtFile.Text = dlgOpen.FileName; 
				}
			}
 
		}

		/// <summary>
		/// Speichern der Datei
		/// </summary>
		private void btnScript_Click(object sender, System.EventArgs e)
		{
			using (SaveFileDialog dlgSave = new SaveFileDialog())
			{
				// Dialog initialisieren
				dlgSave.Filter = "Windows Installer-Skriptdatei (*.tmp)|*.tmp";
				dlgSave.FileName = this.txtScript.Text;

				// Dialog anzeigen
				if (dlgSave.ShowDialog() == DialogResult.OK)
				{
					// Datei in Textfeld anzeigen
					this.txtScript.Text = dlgSave.FileName; 
				}
			}
		}

		/// <summary>
		/// Datei wurde gendert
		/// </summary>
		private void txtFile_TextChanged(object sender, System.EventArgs e)
		{
			// Schaltflche aktivieren / deaktivieren
			this.btnStart.Enabled = ((this.txtFile.Text.Trim() != string.Empty) & (this.txtScript.Text.Trim() != string.Empty));   
		}

		/// <summary>
		/// Abbrechen wurde aktiviert
		/// </summary>
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			// Form schlieen
			this.Close(); 
		}

		/// <summary>
		/// Installation starten
		/// </summary>
		private void btnStart_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Dateiname festlegen
				string packagePath = this.txtFile.Text; 

				if (!File.Exists(packagePath))
				{
					// Datei nicht vorhanden
					throw new FileNotFoundException(string.Format("Die Datei \"{0}\" konnte nicht gefunden werden",packagePath), packagePath); 
				}

				// Plattform auswerten
				uint platform = (uint)this.cmbPlattform.SelectedIndex; 
				if (platform == 3)	platform = 4;

				// Sprache festlegen
				ushort locale = Convert.ToUInt16(this.txtLanguage.Text); 

				// Instanz
				uint instance = (this.chkInstance.Checked?1u:0); 

				// Skript generieren
				MsiFunctions.GenerateAdvertiseScript(packagePath, this.txtScript.Text, this.txtTransform.Text, locale, platform, instance);  

			}
			catch (Exception ex)
			{
				// Exception
				MessageBox.Show(ex.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);     
			}
		}

		#endregion


	}
}
