/**************************************************************************
*
* Filename:     MsiForm.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Formular zum Prfen des Mutex
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace CheckMutex
{
	using System;
	using System.IO;
	using System.Windows.Forms;

	/// <summary>
	/// Formular zum Prfen des Mutex
	/// </summary>
	public class MsiForm : System.Windows.Forms.Form
	{
		#region Controls
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.StatusBarPanel panelVersion;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnCheck;
		private System.Windows.Forms.GroupBox gpMain;
		private System.Windows.Forms.CheckBox chkExist;
		private System.ComponentModel.Container components = null;

		#endregion

		#region Initialisierung / Finalisierung
		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		public MsiForm()
		{
			// Komponenten initialisieren
			InitializeComponent();

			// Version des MSI ermitteln
			this.panelVersion.Text = "Windows Installer-Version: " + Native.GetVersion().ToString();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MsiForm));
			this.btnCheck = new System.Windows.Forms.Button();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.panelVersion = new System.Windows.Forms.StatusBarPanel();
			this.gpMain = new System.Windows.Forms.GroupBox();
			this.chkExist = new System.Windows.Forms.CheckBox();
			this.btnCancel = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).BeginInit();
			this.gpMain.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnCheck
			// 
			this.btnCheck.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCheck.Location = new System.Drawing.Point(232, 16);
			this.btnCheck.Name = "btnCheck";
			this.btnCheck.TabIndex = 0;
			this.btnCheck.Text = "&Prfen";
			this.btnCheck.Click += new System.EventHandler(this.btnCheck_Click);
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 85);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.panelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(320, 22);
			this.stBar.TabIndex = 4;
			// 
			// panelVersion
			// 
			this.panelVersion.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.panelVersion.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.panelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("panelVersion.Icon")));
			this.panelVersion.Width = 304;
			// 
			// gpMain
			// 
			this.gpMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gpMain.Controls.Add(this.chkExist);
			this.gpMain.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.gpMain.Location = new System.Drawing.Point(8, 8);
			this.gpMain.Name = "gpMain";
			this.gpMain.Size = new System.Drawing.Size(216, 64);
			this.gpMain.TabIndex = 5;
			this.gpMain.TabStop = false;
			this.gpMain.Text = "Mutex \"_MSIExecute\" prfen";
			// 
			// chkExist
			// 
			this.chkExist.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.chkExist.Location = new System.Drawing.Point(16, 24);
			this.chkExist.Name = "chkExist";
			this.chkExist.Size = new System.Drawing.Size(120, 24);
			this.chkExist.TabIndex = 0;
			this.chkExist.Text = "Mutex existiert";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(232, 48);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 6;
			this.btnCancel.Text = "B&eenden";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// MsiForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(320, 107);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.gpMain);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.btnCheck);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(328, 136);
			this.Name = "MsiForm";
			this.Text = "Windows Installer 3.1: Mutex";
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).EndInit();
			this.gpMain.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// Haupteinstiegspunkt der Anwendung
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// Styles aktivieren und Form anzeigen
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new MsiForm());
		}
		#endregion

		#region Methoden
		/// <summary>
		/// Mutex wird geprft
		/// </summary>
		private void btnCheck_Click(object sender, System.EventArgs e)
		{
			this.chkExist.Checked = Native.CheckExecuteMutex(); 
		
		}

		/// <summary>
		/// Abbrechen wurde aktiviert
		/// </summary>
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			// Form schlieen
			this.Close(); 
		}
		#endregion
	}
}
