/**************************************************************************
*
* Filename:     MsiForm.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Hauptdialog fr die Anwendung
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace ScriptViewer
{
	using System;
	using System.Windows.Forms;

	/// <summary>
	/// Hauptdialog fr die Anwendung
	/// </summary>
	public class MsiForm : System.Windows.Forms.Form
	{
		#region Controls
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.GroupBox gpMain;
		private System.Windows.Forms.Label lblFile;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtFile;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.ListBox lstData;
		private System.Windows.Forms.TextBox txtOpCode;
		private System.Windows.Forms.Button btnEnd;
		private System.Windows.Forms.StatusBarPanel panelVersion;
		private System.Windows.Forms.TextBox txtProductInfo;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#endregion

		#region Initialisierung / Finalisierung
		/// <summary>
		/// Erstellt eine Instanz des Objektes
		/// </summary>
		public MsiForm()
		{

			// Komponenten initialisieren
			InitializeComponent();

			// Version des MSI ermitteln
			this.panelVersion.Text = "Windows Installer-Version: " + MsiFunctions.GetVersion().ToString();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MsiForm));
			this.gpMain = new System.Windows.Forms.GroupBox();
			this.txtProductInfo = new System.Windows.Forms.TextBox();
			this.lstData = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lblFile = new System.Windows.Forms.Label();
			this.txtOpCode = new System.Windows.Forms.TextBox();
			this.txtFile = new System.Windows.Forms.TextBox();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.panelVersion = new System.Windows.Forms.StatusBarPanel();
			this.btnOpen = new System.Windows.Forms.Button();
			this.btnEnd = new System.Windows.Forms.Button();
			this.gpMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).BeginInit();
			this.SuspendLayout();
			// 
			// gpMain
			// 
			this.gpMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gpMain.Controls.Add(this.txtProductInfo);
			this.gpMain.Controls.Add(this.lstData);
			this.gpMain.Controls.Add(this.label1);
			this.gpMain.Controls.Add(this.lblFile);
			this.gpMain.Controls.Add(this.txtOpCode);
			this.gpMain.Controls.Add(this.txtFile);
			this.gpMain.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.gpMain.Location = new System.Drawing.Point(16, 8);
			this.gpMain.Name = "gpMain";
			this.gpMain.Size = new System.Drawing.Size(464, 400);
			this.gpMain.TabIndex = 2;
			this.gpMain.TabStop = false;
			this.gpMain.Text = "Analysieren der Skriptdatei";
			// 
			// txtProductInfo
			// 
			this.txtProductInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtProductInfo.BackColor = System.Drawing.SystemColors.Window;
			this.txtProductInfo.Location = new System.Drawing.Point(16, 89);
			this.txtProductInfo.Multiline = true;
			this.txtProductInfo.Name = "txtProductInfo";
			this.txtProductInfo.ReadOnly = true;
			this.txtProductInfo.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtProductInfo.Size = new System.Drawing.Size(432, 72);
			this.txtProductInfo.TabIndex = 3;
			this.txtProductInfo.TabStop = false;
			this.txtProductInfo.Text = "";
			// 
			// lstData
			// 
			this.lstData.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstData.IntegralHeight = false;
			this.lstData.Location = new System.Drawing.Point(16, 169);
			this.lstData.Name = "lstData";
			this.lstData.Size = new System.Drawing.Size(432, 127);
			this.lstData.TabIndex = 4;
			this.lstData.SelectedIndexChanged += new System.EventHandler(this.lstData_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(16, 70);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(37, 17);
			this.label1.TabIndex = 2;
			this.label1.Text = "&Inhalt:";
			// 
			// lblFile
			// 
			this.lblFile.AutoSize = true;
			this.lblFile.Location = new System.Drawing.Point(16, 24);
			this.lblFile.Name = "lblFile";
			this.lblFile.Size = new System.Drawing.Size(122, 17);
			this.lblFile.TabIndex = 0;
			this.lblFile.Text = "&Pfad zu der Skriptdatei:";
			// 
			// txtOpCode
			// 
			this.txtOpCode.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtOpCode.BackColor = System.Drawing.SystemColors.Window;
			this.txtOpCode.Location = new System.Drawing.Point(16, 304);
			this.txtOpCode.Multiline = true;
			this.txtOpCode.Name = "txtOpCode";
			this.txtOpCode.ReadOnly = true;
			this.txtOpCode.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtOpCode.Size = new System.Drawing.Size(432, 80);
			this.txtOpCode.TabIndex = 5;
			this.txtOpCode.TabStop = false;
			this.txtOpCode.Text = "";
			// 
			// txtFile
			// 
			this.txtFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtFile.BackColor = System.Drawing.SystemColors.Window;
			this.txtFile.Location = new System.Drawing.Point(16, 46);
			this.txtFile.Name = "txtFile";
			this.txtFile.ReadOnly = true;
			this.txtFile.Size = new System.Drawing.Size(432, 21);
			this.txtFile.TabIndex = 1;
			this.txtFile.TabStop = false;
			this.txtFile.Text = "";
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 421);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.panelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(576, 22);
			this.stBar.TabIndex = 3;
			// 
			// panelVersion
			// 
			this.panelVersion.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.panelVersion.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.panelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("panelVersion.Icon")));
			this.panelVersion.Width = 560;
			// 
			// btnOpen
			// 
			this.btnOpen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOpen.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOpen.Location = new System.Drawing.Point(488, 16);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.TabIndex = 0;
			this.btnOpen.Text = "&ffnen...";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// btnEnd
			// 
			this.btnEnd.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnEnd.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnEnd.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnEnd.Location = new System.Drawing.Point(488, 45);
			this.btnEnd.Name = "btnEnd";
			this.btnEnd.TabIndex = 1;
			this.btnEnd.Text = "B&eenden";
			this.btnEnd.Click += new System.EventHandler(this.btnEnd_Click);
			// 
			// MsiForm
			// 
			this.AcceptButton = this.btnOpen;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.btnEnd;
			this.ClientSize = new System.Drawing.Size(576, 443);
			this.Controls.Add(this.btnEnd);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.gpMain);
			this.Controls.Add(this.btnOpen);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MsiForm";
			this.Text = "Windows Installer 3.1: ScriptViewer";
			this.gpMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new MsiForm());
		}
		#endregion

		#region Methoden
		/// <summary>
		/// Dialog schlieen
		/// </summary>
		private void btnEnd_Click(object sender, System.EventArgs e)
		{
			this.Close(); 
		}

		/// <summary>
		/// Datei ffnen und Inhalte anzeigen
		/// </summary>
		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			using (OpenFileDialog dlgOpen = new OpenFileDialog())
			{
				// Dialog initialisieren
				dlgOpen.Title = "Windows Installer-Skriptdatei auswhlen";
				dlgOpen.Filter = "Windows Installer-Skriptdateien (*.tmp,*.rbs)|*.tmp;*.rbs|Windows Installer-Installationskript (*.tmp)|*.tmp|Windows Installer-Rollbackskript (*.rbs)|*.rbs|Alle Dateien (*.*)|*.*";
				dlgOpen.FileName = this.txtFile.Text;

				// Dialog anzeigen
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					// Daten lschen
					this.lstData.Items.Clear();
					this.txtOpCode.Clear(); 
 
					// Datei in Textfeld anzeigen
					this.txtFile.Text = dlgOpen.FileName; 

					// Callbackfunktion erstellen
					ScriptViewer.LoadDataCallback dataCallback = new LoadDataCallback(this.AddItemsToList ); 

					// Skriptdatei ffnen
					MsiFunctions.ReadScript(this.txtFile.Text, dataCallback);

					// Ersten Eintrag selektieren
					if (this.lstData.Items.Count > 0)
						this.lstData.SelectedIndex = 0;

					this.txtProductInfo.Text = MsiFunctions.GetProductInfoFromScript( this.txtFile.Text);
				}
			}
		}

		/// <summary>
		/// Eintrge der Lise hinzufgen
		/// </summary>
		/// <param name="itemData">Wert der hinzugefgt werden soll</param>
		private void AddItemsToList(string itemData)
		{
			this.lstData.Items.Add(itemData); 
		}

		/// <summary>
		/// Anderer Eintrag in der Liste wurde ausgewhlt
		/// </summary>
		private void lstData_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Eintrag in Textbox anzeigen
			this.txtOpCode.Text = this.lstData.SelectedItem.ToString();  
		}

		#endregion
	}
}
