/**************************************************************************
*
* Filename:     MainForm.cs
* Author:       Andreas Kerl (andreaskerl@msn.com)
*               http://www.microsoft.com/germany/
*
* Description:  Dialog zur Umwandlung einer SQUID in eine GUID
*				
*
*
* Copyright 2005, Andreas Kerl
* 
**************************************************************************/

namespace Squid2Guid
{
	using System;
	using System.Text; 
	using System.Windows.Forms;
	using System.Runtime.InteropServices; 
	/// <summary>
	/// Dialog zur Umwandlung einer SQUID in eine GUID
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		#region Instanzvariablen
		private System.Windows.Forms.TextBox txtSquid;
		private System.Windows.Forms.Label lblSquid;
		private System.Windows.Forms.Button btnCalc;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Label lblResult;
		private System.Windows.Forms.GroupBox gpMain;
		private System.Windows.Forms.StatusBar stBar;
		private System.Windows.Forms.StatusBarPanel panelVersion;
		private System.ComponentModel.Container components = null;
		#endregion

		#region Initialisierung / Finalisierung

		/// <summary>
		/// Initialisierung
		/// </summary>
		public MainForm()
		{
			InitializeComponent();

			// Version des MSI ermitteln
			this.panelVersion.Text = "Windows Installer-Version: " + GetVersion().ToString();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.txtSquid = new System.Windows.Forms.TextBox();
			this.lblSquid = new System.Windows.Forms.Label();
			this.btnCalc = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.lblResult = new System.Windows.Forms.Label();
			this.gpMain = new System.Windows.Forms.GroupBox();
			this.stBar = new System.Windows.Forms.StatusBar();
			this.panelVersion = new System.Windows.Forms.StatusBarPanel();
			this.gpMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).BeginInit();
			this.SuspendLayout();
			// 
			// txtSquid
			// 
			this.txtSquid.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtSquid.Location = new System.Drawing.Point(16, 50);
			this.txtSquid.Name = "txtSquid";
			this.txtSquid.Size = new System.Drawing.Size(272, 21);
			this.txtSquid.TabIndex = 1;
			this.txtSquid.Text = "v[X,qfU0E?q35RF2Nru?";
			// 
			// lblSquid
			// 
			this.lblSquid.AutoSize = true;
			this.lblSquid.Location = new System.Drawing.Point(16, 24);
			this.lblSquid.Name = "lblSquid";
			this.lblSquid.Size = new System.Drawing.Size(133, 17);
			this.lblSquid.TabIndex = 0;
			this.lblSquid.Text = "&Geben Sie die SQUID ein:";
			// 
			// btnCalc
			// 
			this.btnCalc.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCalc.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCalc.Location = new System.Drawing.Point(320, 16);
			this.btnCalc.Name = "btnCalc";
			this.btnCalc.TabIndex = 2;
			this.btnCalc.Text = "&Umwandeln";
			this.btnCalc.Click += new System.EventHandler(this.btnCalc_Click);
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnClose.Location = new System.Drawing.Point(320, 48);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 3;
			this.btnClose.Text = "B&eenden";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// lblResult
			// 
			this.lblResult.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblResult.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblResult.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblResult.Location = new System.Drawing.Point(16, 82);
			this.lblResult.Name = "lblResult";
			this.lblResult.Size = new System.Drawing.Size(272, 38);
			this.lblResult.TabIndex = 4;
			// 
			// gpMain
			// 
			this.gpMain.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gpMain.Controls.Add(this.lblSquid);
			this.gpMain.Controls.Add(this.lblResult);
			this.gpMain.Controls.Add(this.txtSquid);
			this.gpMain.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.gpMain.Location = new System.Drawing.Point(8, 8);
			this.gpMain.Name = "gpMain";
			this.gpMain.Size = new System.Drawing.Size(304, 136);
			this.gpMain.TabIndex = 5;
			this.gpMain.TabStop = false;
			this.gpMain.Text = "SQUID in GUID umwandeln";
			// 
			// stBar
			// 
			this.stBar.Location = new System.Drawing.Point(0, 152);
			this.stBar.Name = "stBar";
			this.stBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					 this.panelVersion});
			this.stBar.ShowPanels = true;
			this.stBar.Size = new System.Drawing.Size(408, 22);
			this.stBar.TabIndex = 6;
			// 
			// panelVersion
			// 
			this.panelVersion.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.panelVersion.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.panelVersion.Icon = ((System.Drawing.Icon)(resources.GetObject("panelVersion.Icon")));
			this.panelVersion.Width = 392;
			// 
			// MainForm
			// 
			this.AcceptButton = this.btnCalc;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.btnClose;
			this.ClientSize = new System.Drawing.Size(408, 174);
			this.Controls.Add(this.stBar);
			this.Controls.Add(this.gpMain);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.btnCalc);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(368, 200);
			this.Name = "MainForm";
			this.Text = "Windows Installer 3.1: Squid -> Guid";
			this.gpMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.panelVersion)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main
		/// <summary>
		/// Main
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents(); 
			Application.Run(new MainForm());
		}
		#endregion

		#region Control Events

		/// <summary>
		/// Der Button zum Berechnen der GUID wurde aktiviert
		/// </summary>
		private void btnCalc_Click(object sender, System.EventArgs e)
		{
			// Descriptor bergebem
			string szDescriptor = this.txtSquid.Text;  

			// Stringbuilder zur Aufnahme der GUID erstellen
			StringBuilder sbGuid = new StringBuilder(39);

			// Offset definieren
			uint offset = 0;

			// Funktion aufrufen
			uint ret = NativeMethods.MsiDecomposeDescriptor(szDescriptor, sbGuid, null, null, ref offset);

			// Daten anzeigen
			this.lblResult.Text = "GUID: " + sbGuid.ToString();
		}
		

		/// <summary>
		/// Die Form wird geschlossen
		/// </summary>
		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close(); 
		}
		#endregion

		#region Methoden
		/// <summary>
		/// Version des Windows Installer ermitteln
		/// </summary>
		/// <returns>ermittelte Version</returns>
		public static Version GetVersion()
		{
			// VersionInfostruktur initialisieren
			uint[] dllVersionInfo = new uint[5];
			dllVersionInfo[0] = 20;
			
			// Version ermitteln
			NativeMethods.DllGetVersion(dllVersionInfo);
			
			// Rckgabe
			return (new Version((int) dllVersionInfo[1], (int) dllVersionInfo[2], (int) dllVersionInfo[3]));
		}

		#endregion

	}

	#region Native Methoden
	/// <summary>
	/// Klasse mit nativen Funktionen
	/// </summary>
	class NativeMethods
	{
		/// <summary>
		/// Ermittelt Informationen ber das Produkt, das Fetaure und/oder die Komponente
		/// </summary>
		/// <param name="Descriptor">Der Descriptor fr das Produkt, das Feature, die Komponente oder eine SQUID</param>
		/// <param name="ProductCode">Stringbuilder der den ProductCode bzw. die Guid aufnehmen soll. Die Kapazitt muss mintestens 39 Zeichen betragen.</param>
		/// <param name="FeatureName">Stringbuilder der den FeatureName aufnehmen soll. Die Kapazitt muss mintestens 39 Zeichen betragen.</param>
		/// <param name="ComponentCode">Stringbuilder der den ComponentCode aufnehmen soll. Die Kapazitt muss mintestens 39 Zeichen betragen.</param>
		/// <param name="Offset">Gibt den Offset des Descriptors an, falls noch zustzliche Argumente bergeben wurden</param>
		/// <returns>ERROR_SUCCESS, falls die Funktion fehlerfrei durchgefhrt wurde</returns>
		[DllImport("msi.dll", CharSet=CharSet.Unicode)] 
		internal static extern uint MsiDecomposeDescriptor(string Descriptor, StringBuilder ProductCode, StringBuilder FeatureName, StringBuilder ComponentCode, ref uint Offset);
	
		/// <summary>
		/// Version des Windows Installers abrufen
		/// </summary>
		/// <param name="dvi"></param>
		[DllImport("msi.dll", CharSet=CharSet.Unicode)]
		internal static extern void DllGetVersion(uint[] dvi);
	}
	#endregion
}
